/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <draw.h>
#include <event.h>

typedef struct gproc gproc;
struct gproc
{
	char *name[6];
	gproc *n;
	gproc *p;
};

Image *textc;
Image *hoverc;
Image *hovertc;
Image *borderc;
Image *backc;
Image *backtc;
Image *scrollc;
Image *sortc;
Image *sorttc;

gproc *glist, *oglist, *aglist;
int f[7], sel, osel, scr, oscr, view, nall, partd, sortn, pid;
Lock scan;
Rectangle scroll;
char *ether0 = "/net/ether0";

char *buttons[] =
{
	"refresh",
	"exit",
	0,
};

char *title[] =
{
	"ssid",
	"bssid",
	"signal",
	"noise",
	"chan",
	"type",
	0
};

enum {
	REFRESH,
	EXIT
};

Menu menu =
{
	buttons
};

void *
reallocg(void *v, ulong n)
{

	v = realloc(v, n);
	if(v == nil)
		sysfatal("no memory allocable.");

	return v;
}

char *
strdupg(char *s)
{
	char *ret;

	ret = reallocg(nil, strlen(s) + 1);
	strcpy(ret, s);
	ret[strlen(s)] = '\0';

	return ret;
}

void
free_gproc(gproc *gl)
{
	char i;

	if(gl != nil) {
		i = -1;
		while(++i < 6)
			if(gl->name[i] != nil)
				free(gl->name[i]);

		free(gl);
	}
	return;
}

void
free_gprocl(gproc *gn)
{
	int n;

	n = -1;

	while(gn != nil) {
		if(gn->n != nil) {
			gn = gn->n;
			free_gproc(gn->p);
			n++;
		} else {
			free_gproc(gn);
			return;
		}
	}
	return;
}

gproc *
get_num(gproc *t, int n)
{

	while(--n > 0)
		if(t != nil)
			t = t->n;
	return t;
}

gproc *
get_last(gproc *t)
{

	if(t != nil)
		while(t->n != nil)
			t = t->n;
	return t;
}

int
get_n(gproc *t)
{
	int ret;

	ret = 0;

	while(t->n != nil) {
		ret++;
		t = t->n;
	}

	return ret;
}

int
compare(gproc *a, gproc *b)
{
	int i;

	if(a->name[sortn] == nil || b->name[sortn] == nil)
		return -1;

	if(strlen(a->name[sortn]) > strlen(b->name[sortn]))
		return -1;
	if(strlen(a->name[sortn]) < strlen(b->name[sortn]))
		return 1;

	i = -1;
	while((a->name[sortn])[++i] != '\0') {
		if((a->name[sortn])[i] < (b->name[sortn])[i])
			return 1;
		if((a->name[sortn])[i] > (b->name[sortn])[i])
			return -1;
	}

	return -1;
}

gproc *
insertsort(gproc *g, short dir)
{
	gproc *s, *n;
	char *t;
	int i;

	if(sortn == -1 || g->n == nil)
		return g;

	s = g;

	while(s->n != nil) {
		n = s;
		while(n != nil) {
 			if(compare(n->n, n) == dir) {
				if(n->n != n) {
					i = -1;
					while(++i < 2) {
						t = n->name[i];
						n->name[i] = n->n->name[i];
						n->n->name[i] = t;
					}
				}
			}
			n = n->p;
		}

		s = s->n;
	}

	return g;
}

gproc *
copy_gproc(gproc *g, gproc *ne, gproc *pr)
{
	gproc *ret;
	int n;

	ret = reallocg(nil, sizeof(gproc));
	ret->p = pr;
	ret->n = ne;
	n = -1;
	while(++n < 6)
		ret->name[n] = strdupg(g->name[n]);

	return ret;
}

gproc *
search_gprocl(gproc *g, char *s)
{

	while(g != nil) {
		if(g->name[1] != nil)
			if(!strcmp(g->name[1], s))
				return g;
		g = g->n;
	}
	return nil;
}

void
do_bsscan(int n)
{
	char *buf, *fp[6], *b;
	int fd0, i;
	gproc *g, *glast, *gnew;

	glast = nil;
	memset(fp, 0, sizeof(char *) * nelem(f));

	buf = smprint("%s/%d/data", ether0, n);
	if(buf == nil)
		sysfatal("no memory allocable.");
	fd0 = open(buf, OREAD);
	if(fd0 < 0)
		sysfatal("Could not open data file of %s: %r", buf);
	free(buf);

	buf = nil;
	while(1) {
		if(buf != nil)
			free(buf);
		buf = reallocg(nil, 513);
		n = read(fd0, buf, 512);
		buf[n - 1] = '\0';
		n = getfields(buf, fp, nelem(fp), 0, ";");
		if(n < 5)
			continue;

		lock(&scan);
		b = strchr(fp[1], '=');
		if(b != nil) {
			b++;
		} else {
			b = fp[1];
		}
		g = search_gprocl(aglist, b);
		if(g != nil) {
			i = -1;
			while(++i < 6) {
				if(i == 5 && n == 5)
					fp[i] = "no wep";
				b = strchr(fp[i], '=');
				if(b != nil) {
					b++;
				} else {
					b = fp[i];
				}
				if(strcmp(g->name[i], b)) {
					free(g->name[i]);
					g->name[i] = strdupg(b);
				}
			}
			unlock(&scan);
			continue;
		}
		if(glast == nil)
			glast = get_last(aglist);
		gnew = reallocg(nil, sizeof(gproc));
		gnew->n = nil;
		gnew->p = glast;
		i = -1;
		while(++i < 6) {
			if(i == 5 && n == 5)
				fp[i] = "no wep";
			b = strchr(fp[i], '=');
			if(b != nil) {
				b++;
			} else {
				b = fp[i];
			}
			gnew->name[i] = strdupg(b);
		}
		if(glast == nil)
			aglist = gnew;
		glast = gnew;
		unlock(&scan);
	}

	return;
}

void
get_bsscan(void)
{
	char *buf;
	int fd0, n;

	buf = smprint("%s/clone", ether0);
	if(buf == nil)
		sysfatal("no memory allocable.");
	fd0 = open(buf, OREAD);
	if(fd0 < 0)
		sysfatal("Could not open clone file of %s: %r", ether0);
	free(buf);

	buf = reallocg(nil, 513);
	if((n = read(fd0, buf, 512)) < 0)
		sysfatal("Could not read from clone file: %r");
	buf[n] = '\0';
	n = atoi(buf);
	free(buf);

	switch((pid = rfork(RFPROC|RFNOWAIT|RFMEM))) {
		case -1:
			sysfatal("Unable to rfork: %r");
		case 0:
			do_bsscan(n);
			exits(0);
		default:
			break;
	}

	buf = smprint("%s/%d/ctl", ether0, n);
	if(buf == nil)
		sysfatal("no memory allocable.");
	fd0 = open(buf, OWRITE);
	if(fd0 < 0)
		sysfatal("Could not open ctl file of %s: %r", buf);
	write(fd0, "scanbs 1\n", 9);
	free(buf);
	close(fd0);

	return;
}

gproc *
get_apscandata(void)
{
	gproc *ret, *ract, *rlast, *rnext;

	rnext = aglist;
	ret = nil;
	ract = nil;

	lock(&scan);
	while(rnext != nil) {
		rlast = copy_gproc(rnext, nil, nil);
		if(ret == nil) {
			ract = ret = rlast;
		} else {
			ract->n = rnext;
			rlast->p = ract;
			ract = rnext;
		}
		rnext = rnext->n;
	}
	unlock(&scan);

	ret = insertsort(ret, -1);

	return ret;
}

void
draw_scrollbar(Rectangle r)
{

	partd = Dy(r) / (nall + 1);

	draw(screen, r, scrollc, nil, ZP);
	if((scr + view) * partd <= Dy(r))
	{
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.min.y + partd * (scr + view)), backc, nil, ZP);
	} else {
		draw(screen, Rect(r.min.x, r.min.y + partd * scr, r.max.x, r.max.y), backc, nil, ZP);
	}

	return;
}

void
draw_apscan(int g)
{
	int d, e;
	gproc *n, *no;
	Point max;
	char *a;

	if(g > 0)
	{
		if(glist != nil)
		{
			if(oglist != nil)
				free_gprocl(oglist);
			oglist = glist;
		}

		glist = get_apscandata();
	}

	e = (screen->r.max.x - screen->r.min.x - 15) / 10;

	if(g > 3)
		draw(screen, screen->r, backc, nil, ZP);

	max = screen->r.max;
	max.y--;
	max.x--;

	d = screen->r.min.x;

	if(g > 3)
	{
		line(screen, (Point){d, screen->r.min.y}, (Point){max.x, screen->r.min.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){max.x, screen->r.min.y}, max, 0, 0, 0, borderc, ZP);
		line(screen, max, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
		line(screen, (Point){d, max.y}, (Point){d, screen->r.min.y}, 0, 0, 0, borderc, ZP);
	}

	f[0] = screen->r.min.x + 12;
	d += 12;
	scroll = Rect(screen->r.min.x + 1, screen->r.min.y + 3 + font->height, d, screen->r.max.y - 1);
	if(g > 3)
	{
		draw(screen, Rect(screen->r.min.x + 1, screen->r.min.y + 1, d, screen->r.min.y + 2 + font->height), borderc, nil, ZP);
		draw(screen, Rect(screen->r.min.x + 2, screen->r.min.y + 2, d - 1, screen->r.min.y + 1 + font->height), backtc, nil, ZP);
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	}

	d += 1 * e;
	f[1] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 4 * e;
	f[2] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 1 * e;
	f[3] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 1 * e;
	f[4] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	d += 1 * e;
	f[5] = d;
	if(g > 3)
		line(screen, (Point){d, screen->r.min.y}, (Point){d, max.y}, 0, 0, 0, borderc, ZP);
	f[6] = max.x;
	if(g > 3)
		line(screen, (Point){screen->r.min.x, screen->r.min.y + font->height + 2}, (Point){max.x, screen->r.min.y + font->height + 2}, 0, 0, 0, borderc, ZP);

	if(g > 2)
	{
		e = -1;
		while(title[++e] != 0)
		{
			draw(screen, Rect(f[e] + 1, screen->r.min.y + 1, f[e + 1], screen->r.min.y + 2 + font->height), (e == sortn) ? sortc : backtc, nil, ZP);

			a = strdupg(title[e]);
			if(stringwidth(font, a) >= f[e + 1] - f[e])
				a[strlen(a) - ((stringwidth(font, a) - f[e + 1] + f[e] + 2) / (stringwidth(font, a) / strlen(a)) + 1)] = '\0';
			string(screen, (Point){f[e] + (f[e + 1] - f[e]) / 2 - stringwidth(font, a) / 2, screen->r.min.y + 1}, (e == sortn) ? sorttc : textc, ZP, font, a);
			free(a);
		}
	}

	d = 0;
	n = get_num(glist, scr);
	no = get_num(oglist, scr);
	while(n != nil && ((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 6)
		{
			if(no != nil && g < 1 && d != sel && d != osel)
				if(!strcmp(no->name[e], n->name[e]))
					goto items_none;

			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), (d == sel) ? hoverc : backc, nil, ZP);

			if(n->name[e] != nil)
			{
				if(stringwidth(font, n->name[e]) >= f[e + 1] - f[e])
					(n->name[e])[strlen(n->name[e]) - ((stringwidth(font, n->name[e]) - f[e + 1] + f[e]) / (stringwidth(font, n->name[e]) / strlen(n->name[e])) + 1)] = '\0';
				string(screen, (Point){f[e] + 2, screen->r.min.y + 3 + font->height * d}, (d == sel) ? hovertc : textc, ZP, font, n->name[e]);
			}
		}
items_none:
		if(no != nil)
			no = no->n;
		n = n->n;
	}

	while(((d + 2) * font->height + 3) < Dy(screen->r))
	{
		d++;
		e = -1;
		while(++e < 9)
			draw(screen, Rect(f[e] + 1, screen->r.min.y + 3 + font->height * d, f[e + 1], screen->r.min.y + 3 + font->height * (d + 1)), backc, nil, ZP);
	}

	if(g > 1)
		view = d;
	if(glist != nil)
		nall = get_n(glist);

	draw_scrollbar(scroll);

	return;
}

void
eresized(int new)
{

	if(new && getwindow(display, Refnone) < 0)
		sysfatal("can't reattach to window");

	draw_apscan(4);

	return;
}

void
usage(void)
{

	print("usage: gapscan [-x ether0] [-s sec] [-o sort] [-e sel]\n");
	return;
}

void
main(int argc, char *argv[])
{
	int sec, Etimer, fd;
	Event e;
	char *killb;

	sec = 1;
	scr = 0;
	sel = -1;
	sortn = -1;

	if(initdraw(nil, nil, "gapscan") < 0)
		sysfatal("initdraw failed: %r");

	ARGBEGIN {
		case 'x':
			ether0 = EARGF(usage());
			break;
		case 's':
			sec = atoi(EARGF(usage()));
			break;
		case 'o':
			sortn = atoi(EARGF(usage()));
			break;
		case 'e':
			sel = atoi(EARGF(usage()));
			break;
		default:
			usage();
			exits(0);
	} ARGEND;

	backc = allocimagemix(display, DPaleyellow, DWhite);
	if(backc == nil)
		sysfatal("allocimagemix: %r");
	textc = allocimagemix(display, DBlack, DBlack);
	if(textc == nil)
		sysfatal("allocimagemix: %r");
	hoverc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(hoverc == nil)
		sysfatal("allocimagemix: %r");
	borderc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(borderc == nil)
		sysfatal("allocimagemix: %r");
	hovertc = allocimagemix(display, DBlack, DBlack);
	if(hovertc == nil)
		sysfatal("allocimagemix: %r");
	backtc = allocimagemix(display, DPalebluegreen, DWhite);
	if(backtc == nil)
		sysfatal("allocimagemix: %r");
	scrollc = allocimagemix(display, DPurpleblue, DPurpleblue);
	if(scrollc == nil)
		sysfatal("allocimagemix: %r");
	sortc = allocimagemix(display, DDarkyellow, DDarkyellow);
	if(sortc == nil)
		sysfatal("allocimagemix: %r");
	sorttc = allocimagemix(display, DBlack, DBlack);
	if(sorttc == nil)
		sysfatal("allocimagemix: %r");

	get_bsscan();

	eresized(0);

	einit(Emouse);
	Etimer = etimer(0, sec * 1000);

	while(1)
	{
		switch(eread(Emouse|Etimer, &e))
		{
			case Emouse:
				if(e.mouse.buttons & 1)
				{
					if(e.mouse.xy.y < screen->r.min.y + font->height + 2)
					{
						fd = -1;
						while(++fd < 6)
						{
							if(e.mouse.xy.x < f[fd + 1] && e.mouse.xy.x >= f[fd])
							{
								if(sortn == fd)
								{
									sortn = -1;
								} else {
									sortn = fd;
								}
								draw_apscan(3);
								break;
							}
						}
						break;
					}
					if(e.mouse.xy.x < screen->r.min.x + 15)
					{
						if((scr - view / 2) <= 0)
						{
							scr = 0;
						} else {
							scr -= view / 2;
						}

						draw_apscan(2);
					} else {
						osel = sel;
						fd = (e.mouse.xy.y - screen->r.min.y - 1) / font->height;
						if(fd == sel)
						{
							sel = 0;
						} else {
							sel = fd;
						}

						draw_apscan(0);
					}
					break;
				}
				if(e.mouse.buttons & 2)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr = (e.mouse.xy.y - scroll.min.y) / partd;
						draw_apscan(2);
					}
					break;
				}
				if(e.mouse.buttons & 4)
				{
					if(e.mouse.xy.x < screen->r.min.x + 15 && e.mouse.xy.y > screen->r.min.y + font->height + 2)
					{
						scr += view / 2;
						draw_apscan(2);
						break;
					}
					switch(emenuhit(3, &e.mouse, &menu))
					{
						case REFRESH:
							draw_apscan(1);
							break;
						case EXIT:
							goto free_all;
						default:
							break;
					}
				}
				break;
			default:
				draw_apscan(1);
				break;
		}
		sleep(1);
	}

free_all:

	killb = smprint("/proc/%d/ctl", pid);
	if(killb == nil)
		sysfatal("No memory for exit");
	fd = open(killb, OWRITE);
	if(fd < 0)
		sysfatal("Could not kill the child");
	write(fd, "kill", 4);
	close(fd);
	free(killb);

	freeimage(textc);
	freeimage(hoverc);
	freeimage(backc);
	freeimage(hovertc);
	freeimage(borderc);
	freeimage(backtc);
	freeimage(scrollc);
	freeimage(sortc);
	freeimage(sorttc);

	if(glist != nil)
		free_gprocl(glist);
	if(oglist != nil)
		free_gprocl(oglist);
	if(aglist != nil)
		free_gprocl(aglist);

	exits(0);
}
